import { generateSchemaWithInputSlices } from "./schema";
import type { ExtendSimulationSchemaInput } from "./schema";
import type { AnyState, StoreUpdater } from "starfx";
import { createStore, createSelector } from "starfx";
import { createThunks } from "starfx";
type StoreThunks = ReturnType<typeof createThunks>;
type GeneratedSchema<ExtendedSimulationSchema> = ReturnType<typeof generateSchemaWithInputSlices<ExtendedSimulationSchema>>;
type GeneratedStore<ExtendedSimulationSchema> = ReturnType<typeof createStore<GeneratedSchema<ExtendedSimulationSchema>[1]>>;
export type ExtendSimulationActionsInput<Actions, ExtendedSimulationSchema> = (arg: {
    thunks: StoreThunks;
    store: GeneratedStore<ExtendedSimulationSchema>;
    schema: GeneratedSchema<ExtendedSimulationSchema>[0];
}) => Actions;
export type ExtendSimulationSelectorsInput<Selectors, ExtendedSimulationSchema> = (arg: {
    store: GeneratedStore<ExtendedSimulationSchema>;
    schema: GeneratedSchema<ExtendedSimulationSchema>[0];
    createSelector: typeof createSelector;
}) => Selectors;
export declare function createSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions, ExtendedSimulationSelectors>({ actions: inputActions, selectors: inputSelectors, schema: inputSchema, logs, }?: {
    schema: ExtendSimulationSchemaInput<ExtendedSimulationSchema>;
    actions: ExtendSimulationActionsInput<ExtendedSimulationActions, ExtendedSimulationSchema>;
    selectors: ExtendSimulationSelectorsInput<ExtendedSimulationSelectors, ExtendedSimulationSchema>;
    logs?: boolean;
}): {
    store: import("starfx").FxStore<{
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
        simulationLogs: (n: string) => import("starfx").TableOutput<import("./schema").SimulationLog, AnyState, import("./schema").SimulationLog | undefined>;
        simulationRoutes: (n: string) => import("starfx").TableOutput<import("./schema").SimulationRoute, AnyState, import("./schema").SimulationRoute>;
    } & ExtendedSimulationSchema extends infer T extends import("starfx").FxMap ? { [key in keyof T]: ReturnType<({
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
        simulationLogs: (n: string) => import("starfx").TableOutput<import("./schema").SimulationLog, AnyState, import("./schema").SimulationLog | undefined>;
        simulationRoutes: (n: string) => import("starfx").TableOutput<import("./schema").SimulationRoute, AnyState, import("./schema").SimulationRoute>;
    } & ExtendedSimulationSchema)[key]>["initialState"]; } : never>;
    schema: import("starfx").FxSchema<{
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
        simulationLogs: (n: string) => import("starfx").TableOutput<import("./schema").SimulationLog, AnyState, import("./schema").SimulationLog | undefined>;
        simulationRoutes: (n: string) => import("starfx").TableOutput<import("./schema").SimulationRoute, AnyState, import("./schema").SimulationRoute>;
    } & ExtendedSimulationSchema extends infer T_1 extends import("starfx").FxMap ? { [key in keyof T_1]: ReturnType<({
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
        simulationLogs: (n: string) => import("starfx").TableOutput<import("./schema").SimulationLog, AnyState, import("./schema").SimulationLog | undefined>;
        simulationRoutes: (n: string) => import("starfx").TableOutput<import("./schema").SimulationRoute, AnyState, import("./schema").SimulationRoute>;
    } & ExtendedSimulationSchema)[key]>["initialState"]; } : never, {
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
        simulationLogs: (n: string) => import("starfx").TableOutput<import("./schema").SimulationLog, AnyState, import("./schema").SimulationLog | undefined>;
        simulationRoutes: (n: string) => import("starfx").TableOutput<import("./schema").SimulationRoute, AnyState, import("./schema").SimulationRoute>;
    } & ExtendedSimulationSchema>;
    actions: {
        simulationLog: import("starfx").CreateActionWithPayload<Omit<import("starfx").ThunkCtx<any>, "payload"> & import("starfx").Payload<{
            method: string;
            url: string;
            query: Record<string, any>;
            body: any;
        }>, {
            method: string;
            url: string;
            query: Record<string, any>;
            body: any;
        }, any>;
        batchUpdater: import("starfx").CreateActionWithPayload<Omit<import("starfx").ThunkCtx<any>, "payload"> & import("starfx").Payload<StoreUpdater<AnyState>[]>, StoreUpdater<AnyState>[], any>;
    } & ExtendedSimulationActions;
    selectors: ExtendedSimulationSelectors;
};
type CreateSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions, ExtendedSimulationSelectors> = typeof createSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions, ExtendedSimulationSelectors>;
export type SimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions, ExtendedSimulationSelectors> = ReturnType<CreateSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions, ExtendedSimulationSelectors>>;
export type ExtendSimulationActions<InputSchema extends ExtendSimulationSchemaInput<any>> = {
    thunks: StoreThunks;
    store: GeneratedStore<ReturnType<InputSchema>>;
    schema: GeneratedSchema<ReturnType<InputSchema>>[0];
};
export type ExtendSimulationSelectors<InputSchema extends ExtendSimulationSchemaInput<any>> = {
    store: GeneratedStore<ReturnType<InputSchema>>;
    schema: GeneratedSchema<ReturnType<InputSchema>>[0];
    createSelector: typeof createSelector;
};
export {};
//# sourceMappingURL=index.d.ts.map