import { slice as immerSlice } from "starfx";
type SimulationSlice = typeof immerSlice;
export type ExtendSimulationSchema = {
    slice: SimulationSlice;
};
export type ExtendSimulationSchemaInput<T> = ({ slice, }: ExtendSimulationSchema) => T;
export interface SimulationLog {
    timestamp: number;
    level: "debug" | "info" | "error";
    message: string;
    meta?: Record<string, any>;
}
export interface SimulationRoute {
    type: "JSON" | "OpenAPI" | "Explicit";
    url: string;
    method: "get" | "post" | "delete" | "patch";
    calls: number;
    defaultCode: number;
    responses: number[];
}
export declare function generateSchemaWithInputSlices<ExtendedSimulationSchema>(inputSchema: ExtendSimulationSchemaInput<ExtendedSimulationSchema>): [import("starfx").FxSchema<{
    cache: (n: string) => import("starfx").TableOutput<{}, import("starfx").AnyState, {}>;
    loaders: (name: string) => import("starfx").LoaderOutput<M, import("starfx").AnyState>;
    simulationLogs: (n: string) => import("starfx").TableOutput<SimulationLog, import("starfx").AnyState, SimulationLog | undefined>;
    simulationRoutes: (n: string) => import("starfx").TableOutput<SimulationRoute, import("starfx").AnyState, SimulationRoute>;
} & ExtendedSimulationSchema extends infer T extends import("starfx").FxMap ? { [key in keyof T]: ReturnType<({
    cache: (n: string) => import("starfx").TableOutput<{}, import("starfx").AnyState, {}>;
    loaders: (name: string) => import("starfx").LoaderOutput<M, import("starfx").AnyState>;
    simulationLogs: (n: string) => import("starfx").TableOutput<SimulationLog, import("starfx").AnyState, SimulationLog | undefined>;
    simulationRoutes: (n: string) => import("starfx").TableOutput<SimulationRoute, import("starfx").AnyState, SimulationRoute>;
} & ExtendedSimulationSchema)[key]>["initialState"]; } : never, {
    cache: (n: string) => import("starfx").TableOutput<{}, import("starfx").AnyState, {}>;
    loaders: (name: string) => import("starfx").LoaderOutput<M, import("starfx").AnyState>;
    simulationLogs: (n: string) => import("starfx").TableOutput<SimulationLog, import("starfx").AnyState, SimulationLog | undefined>;
    simulationRoutes: (n: string) => import("starfx").TableOutput<SimulationRoute, import("starfx").AnyState, SimulationRoute>;
} & ExtendedSimulationSchema>, {
    cache: (n: string) => import("starfx").TableOutput<{}, import("starfx").AnyState, {}>;
    loaders: (name: string) => import("starfx").LoaderOutput<M, import("starfx").AnyState>;
    simulationLogs: (n: string) => import("starfx").TableOutput<SimulationLog, import("starfx").AnyState, SimulationLog | undefined>;
    simulationRoutes: (n: string) => import("starfx").TableOutput<SimulationRoute, import("starfx").AnyState, SimulationRoute>;
} & ExtendedSimulationSchema extends infer T_1 extends import("starfx").FxMap ? { [key in keyof T_1]: ReturnType<({
    cache: (n: string) => import("starfx").TableOutput<{}, import("starfx").AnyState, {}>;
    loaders: (name: string) => import("starfx").LoaderOutput<M, import("starfx").AnyState>;
    simulationLogs: (n: string) => import("starfx").TableOutput<SimulationLog, import("starfx").AnyState, SimulationLog | undefined>;
    simulationRoutes: (n: string) => import("starfx").TableOutput<SimulationRoute, import("starfx").AnyState, SimulationRoute>;
} & ExtendedSimulationSchema)[key]>["initialState"]; } : never];
export {};
//# sourceMappingURL=schema.d.ts.map